namespace devtm.Aop.Emit
{
    using System;
    using System.Collections;
    using System.Reflection;
    

    [Serializable]
    public class EmitTypeReferenceCollection : CollectionBase
    {
        public EmitTypeReferenceCollection()
        {

        }

        public EmitTypeReferenceCollection(EmitTypeReferenceCollection value)
        {
            this.AddRange(value);
        }

        public EmitTypeReferenceCollection(EmitTypeReference[] value)
        {
            this.AddRange(value);
        }

        public int Add(EmitTypeReference value)
        {
            return base.List.Add(value);
        }


        public void AddRange(EmitTypeReference[] value)
        {
            if (value == null)
            {
                throw new ArgumentNullException("value");
            }
            for (int i = 0; i < value.Length; i++)
            {
                this.Add(value[i]);
            }
        }

        public void AddRange(EmitTypeReferenceCollection value)
        {
            if (value == null)
            {
                throw new ArgumentNullException("value");
            }
            int count = value.Count;
            for (int i = 0; i < count; i++)
            {
                this.Add(value[i]);
            }
        }

        public bool Contains(EmitTypeReference value)
        {
            return base.List.Contains(value);
        }

        public void CopyTo(EmitTypeReference[] array, int index)
        {
            base.List.CopyTo(array, index);
        }

        public int IndexOf(EmitTypeReference value)
        {
            return base.List.IndexOf(value);
        }

        public void Insert(int index, EmitTypeReference value)
        {
            base.List.Insert(index, value);
        }

        public void Remove(EmitTypeReference value)
        {
            base.List.Remove(value);
        }

        public EmitTypeReference this[int index]
        {
            get
            {
                return (EmitTypeReference)base.List[index];
            }
            set
            {
                base.List[index] = value;
            }
        }
    }
}
