namespace devtm.Aop.Emit
{
    using System;
    using System.Collections;
    using System.Reflection;
    

    [Serializable]
    public class EmitExpressionCollection : CollectionBase
    {

        public EmitExpressionCollection()
        {
        }

        public EmitExpressionCollection(EmitExpressionCollection value)
        {
            this.AddRange(value);
        }

        public EmitExpressionCollection(EmitExpression[] value)
        {
            this.AddRange(value);
        }

        public int Add(EmitExpression value)
        {
            return base.List.Add(value);
        }

        public void AddRange(EmitExpression[] value)
        {
            if (value == null)
                throw new ArgumentNullException("value");

            for (int i = 0; i < value.Length; i++)
                this.Add(value[i]);

        }

        public void AddRange(EmitExpressionCollection value)
        {
            if (value == null)
                throw new ArgumentNullException("value");

            int count = value.Count;
            for (int i = 0; i < count; i++)
                this.Add(value[i]);

        }

        public bool Contains(EmitExpression value)
        {
            return base.List.Contains(value);
        }

        public void CopyTo(EmitExpression[] array, int index)
        {
            base.List.CopyTo(array, index);
        }

        public int IndexOf(EmitExpression value)
        {
            return base.List.IndexOf(value);
        }

        public void Insert(int index, EmitExpression value)
        {
            base.List.Insert(index, value);
        }

        public void Remove(EmitExpression value)
        {
            base.List.Remove(value);
        }

        public EmitExpression this[int index]
        {
            get
            {
                return (EmitExpression) base.List[index];
            }
            set
            {
                base.List[index] = value;
            }
        }
    }
}
