namespace devtm.Emit
{
    using System;
    using System.Collections;
    using System.Reflection;
    

    [Serializable]
    public class ParameterDeclarationExpressionCollection : CollectionBase
    {
        public ParameterDeclarationExpressionCollection()
        {
        }

        public ParameterDeclarationExpressionCollection(ParameterDeclarationExpressionCollection value)
        {
            this.AddRange(value);
        }

        public ParameterDeclarationExpressionCollection(EmitParameterDeclarationExpression[] value)
        {
            this.AddRange(value);
        }

        public int Add(EmitParameterDeclarationExpression value)
        {
            return base.List.Add(value);
        }

        public void AddRange(EmitParameterDeclarationExpression[] value)
        {
            if (value == null)
            {
                throw new ArgumentNullException("value");
            }
            for (int i = 0; i < value.Length; i++)
            {
                this.Add(value[i]);
            }
        }

        public void AddRange(ParameterDeclarationExpressionCollection value)
        {
            if (value == null)
            {
                throw new ArgumentNullException("value");
            }
            int count = value.Count;
            for (int i = 0; i < count; i++)
            {
                this.Add(value[i]);
            }
        }

        public bool Contains(EmitParameterDeclarationExpression value)
        {
            return base.List.Contains(value);
        }

        public void CopyTo(EmitParameterDeclarationExpression[] array, int index)
        {
            base.List.CopyTo(array, index);
        }

        public int IndexOf(EmitParameterDeclarationExpression value)
        {
            return base.List.IndexOf(value);
        }

        public void Insert(int index, EmitParameterDeclarationExpression value)
        {
            base.List.Insert(index, value);
        }

        public void Remove(EmitParameterDeclarationExpression value)
        {
            base.List.Remove(value);
        }

        public EmitParameterDeclarationExpression this[int index]
        {
            get
            {
                return (EmitParameterDeclarationExpression) base.List[index];
            }
            set
            {
                base.List[index] = value;
            }
        }
    }
}
