namespace devtm.Aop.Emit
{
    using System;
    using System.Collections;
    using System.Reflection;
    

    [Serializable]
    public class CatchClauseCollection : CollectionBase
    {
        public CatchClauseCollection()
        {
        }

        public CatchClauseCollection(CatchClauseCollection value)
        {
            this.AddRange(value);
        }

        public CatchClauseCollection(EmitCatchClause[] value)
        {
            this.AddRange(value);
        }

        public int Add(EmitCatchClause value)
        {
            return base.List.Add(value);
        }

        public void AddRange(EmitCatchClause[] value)
        {
            if (value == null)
            {
                throw new ArgumentNullException("value");
            }
            for (int i = 0; i < value.Length; i++)
            {
                this.Add(value[i]);
            }
        }

        public void AddRange(CatchClauseCollection value)
        {
            if (value == null)
            {
                throw new ArgumentNullException("value");
            }
            int count = value.Count;
            for (int i = 0; i < count; i++)
            {
                this.Add(value[i]);
            }
        }

        public bool Contains(EmitCatchClause value)
        {
            return base.List.Contains(value);
        }

        public void CopyTo(EmitCatchClause[] array, int index)
        {
            base.List.CopyTo(array, index);
        }

        public int IndexOf(EmitCatchClause value)
        {
            return base.List.IndexOf(value);
        }

        public void Insert(int index, EmitCatchClause value)
        {
            base.List.Insert(index, value);
        }

        public void Remove(EmitCatchClause value)
        {
            base.List.Remove(value);
        }

        public EmitCatchClause this[int index]
        {
            get
            {
                return (EmitCatchClause) base.List[index];
            }
            set
            {
                base.List[index] = value;
            }
        }
    }
}
