namespace devtm.Aop.Emit
{
    using System;
    using System.Collections;
    using System.Reflection;
    

    [Serializable]
    public class EmitStatementCollection : CollectionBase
    {
        public EmitStatementCollection()
        {
        }


        public EmitStatementCollection(EmitStatementCollection value)
        {
            this.AddRange(value);
        }

        public EmitStatementCollection(EmitStatement[] value)
        {
            this.AddRange(value);
        }

        public int Add(EmitExpression value)
        {
            return this.Add(new EmitExpressionStatement(value));
        }

        public int Add(EmitStatement value)
        {
            return base.List.Add(value);
        }

        public void AddRange(EmitStatement[] value)
        {
            if (value == null)
            {
                throw new ArgumentNullException("value");
            }
            for (int i = 0; i < value.Length; i++)
            {
                this.Add(value[i]);
            }
        }

        public void AddRange(EmitStatementCollection value)
        {
            if (value == null)
            {
                throw new ArgumentNullException("value");
            }
            int count = value.Count;
            for (int i = 0; i < count; i++)
            {
                this.Add(value[i]);
            }
        }

        public bool Contains(EmitStatement value)
        {
            return base.List.Contains(value);
        }

        public void CopyTo(EmitStatement[] array, int index)
        {
            base.List.CopyTo(array, index);
        }

        public int IndexOf(EmitStatement value)
        {
            return base.List.IndexOf(value);
        }

        public void Insert(int index, EmitStatement value)
        {
            base.List.Insert(index, value);
        }

        public void Remove(EmitStatement value)
        {
            base.List.Remove(value);
        }

        public EmitStatement this[int index]
        {
            get
            {
                return (EmitStatement) base.List[index];
            }
            set
            {
                base.List[index] = value;
            }
        }
    }
}
