﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.Diagnostics;
using Wcf.Contract;
using Wcf.Implementation;
using System.Threading;
using devtm.Aop.Linq;


namespace System.ServiceModel.Dynamic.Test
{
    [TestClass]
    public class UnitTest1 : Wcf.Contract.IMyCallbackService
    {

       

        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{           
        //}
        
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{            
        //}

        [TestMethod]
        public void TestMethod1()
        {

            ServiceHost WcfServiceHost = new ServiceHost(typeof(Service));
            WcfServiceHost.Open();

            IMyService c = null;

            try
            {

                c = WcfWrapperFactory.Create<IMyService>("wsHttpBindingIMyService", "http://localhost:1826/MyService");

                //c = new Dynamic_ClientForIMyService("wsHttpBindingIMyService", "http://localhost:1826/MyService");

            }
            catch (Exception ex)
            {
                StackTrace s = new StackTrace(ex);
                throw;
            }
            Assert.AreNotEqual(c, null);
            string filename = c.GetType().Assembly.Location;


            try
            {
                var r1 = c.MyOperation1(new MyMessage() { Id = 12, Name = "Test" });
                Assert.AreEqual(r1, "Test");

                var r2 = c.MyOperation2(12);
                Assert.AreEqual(r2, "12");

                var r3 = c.MyOperation3(12, "test2");
                Assert.AreEqual(r3.Id, 12);
                Assert.AreEqual(r3.Name, "test2");

                var r4 = c.MyOperation4(10, ref r2);
                Assert.AreEqual(r4, true);
                Assert.AreEqual(r2, "ok");

                int i = 3;
                var r5 = c.MyOperation5(ref i);
                Assert.AreEqual(i, 100);
                Assert.AreEqual(r4, true);

                var r6 = c.MyOperation6(out i);
                Assert.AreEqual(i, 55);
                Assert.AreEqual(r6, true);


            }
            catch (Exception ex1)
            {

                StackTrace s2 = new StackTrace(ex1);

                throw;
            }

            WcfServiceHost.Close();

        }



        [TestMethod]
        public void TestMethod2()
        {

            ServiceHost WcfServiceHost = new ServiceHost(typeof(ServiceAsync));
            WcfServiceHost.Open();

            IMyServiceAsync c = null;

            try
            {

                //ProxyRuntime<IMyServiceAsync> p = ProxyRuntime.For<IMyServiceAsync>();
                //p.GroupMethod()
                //    .Select(d => d.MyOperation1(null))
                //    .AddInterceptor
                //(
                //    devtm.Cecil.Event.InterceptEnumEventType.BeforeCall,
                //    (sender, arg, index) =>
                //    {

                //    }
                //);


                ProxyBuild<IMyServiceAsync> proxy = Proxy.ForBuild<IMyServiceAsync>();

                proxy.GroupMethod()
                    .Select("MyOperation1", typeof(MyMessage))
                    .AddInterceptor(devtm.Aop.Event.InterceptEnumEventType.BeforeCall, 
                    (s, a, IndexOutOfRangeException) =>
                        {
                            //foreach (var item in a.parameters)
                            //{
                            //    MyMessage i = item as MyMessage;
                            //    if (i == null)
                            //        throw new ArgumentNullException("message");

                            //}
                        }
                    );

                WcfWrapperFactory.Initialize<IMyServiceAsync>(proxy);

                var callback = new InstanceContext(this);
                c = WcfWrapperFactory.Create<IMyServiceAsync>(
                    callback
                    , "wsDualHttpBindingIMyServiceAsync"
                    , new Wcf.Implementation.Behaviors.Validation.ValidationEndpointBehavior());

            }
            catch (Exception ex)
            {
                StackTrace s = new StackTrace(ex);
                throw;
            }

            Assert.AreNotEqual(c, null);
            string filename = c.GetType().Assembly.Location;

            test = false;
            try
            {
                c.MyOperation1(new MyMessage() { Id = 12, Name = "Test" });                          
            }
            catch (Exception ex1)
            {
                StackTrace s2 = new StackTrace(ex1);
                throw;
            }

            while (!test)
            {
                System.Threading.Thread.Sleep(1);
            }

        }

        private bool test;

        public void MyCallbackOperation1(MyMessage message)
        {
            test = true;
        }



        [TestMethod]
        public void TestMethod3()
        {

            ServiceHost WcfServiceHost = new ServiceHost(typeof(ServiceResolved));
            WcfServiceHost.Open();

            IMyServiceGenericResolved c = null;

            try
            {
                c = WcfWrapperFactory.Create<IMyServiceGenericResolved>("wsHttpBindingIMyServiceGenericResolved");   
                //c = new ClassContractTest("wsHttpBindingIMyServiceGenericResolved");

            }
            catch (Exception ex)
            {
                StackTrace s = new StackTrace(ex);
                throw;
            }
            Assert.AreNotEqual(c, null);
            string filename = c.GetType().Assembly.Location;


            try
            {

                var r1 = c.MyOperation1(new MyMessage() { Id = 12, Name = "Test" });
                Assert.AreEqual(r1, "Test");

                var r2 = c.MyOperation2(new MyMessage() { Id = 12, Name = "Test" });
                Assert.AreEqual(r1, "Test");

            }
            catch (Exception ex1)
            {

                StackTrace s2 = new StackTrace(ex1);

                throw;
            }

            WcfServiceHost.Close();

        }


    }
}
