using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace System.ServiceModel.Dynamic.Test.ServiceModel.Cache
{
    
    public class CacheFactory
    {


        private static CacheFactory _instance;

        public const string DefaultCache = "MemoryCache";


        private CacheFactory()
        {

        }


        static CacheFactory()
        {
            _instance = new CacheFactory();
        }


        public static CacheFactory Instance
        {
            get
            {
                return _instance;
            }
        }


        public bool Exists(string cacheType)
        {
            return true;
        }


        internal ICache Get(string cacheName)
        {

            if (cacheName == DefaultCache && _dic.Count == 0)
                RegisterType(typeof(System.ServiceModel.Dynamic.Test.ServiceModel.Cache.Providers.MemoryCache), DefaultCache);


            if (_dic.ContainsKey(cacheName))
                return _dic[cacheName];


            Type t = Type.GetType(cacheName);
            if (t != null)
            {

                return RegisterType(t, cacheName);

            }

            return null;
        }


        public ICache RegisterType(Type type)
        {
            ICache c = RegisterType(type, type.GetType().Name);
            return c;
        }


        public ICache RegisterType(Type type, string nameCache)
        {

            ICache c = Activator.CreateInstance(type) as ICache;

            if (c != null)
                _dic.Add(nameCache, c);

            return c;

        }

        public ICache RegisterType(ICache cache, string nameCache)
        {

            _dic.Add(nameCache, cache);

            return cache;

        }

        private Dictionary<string, ICache> _dic = new Dictionary<string, ICache>();


    }

    
}
