using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel.Configuration;
using System.Configuration;

namespace System.ServiceModel.Dynamic.Test.ServiceModel.Cache.Configuration
{
    public class OperationElementCollection : ConfigurationElementCollection
    {
        #region Public Constructor
        public OperationElementCollection()
        {

        } 
        #endregion

        #region Public Properties
        public override ConfigurationElementCollectionType CollectionType
        {
            get
            {
                return ConfigurationElementCollectionType.AddRemoveClearMap;
            }
        }

        public OperationElement this[int index]
        {
            get
            {
                return (OperationElement)BaseGet(index);
            }
            set
            {
                if (BaseGet(index) != null)                
                    BaseRemoveAt(index);
                
                BaseAdd(index, value);
            }
        }

        new public OperationElement this[string Name]
        {
            get
            {
                return (OperationElement)BaseGet(Name);
            }
        }
        #endregion

        #region Public Methods
        protected override ConfigurationElement CreateNewElement()
        {
            return new OperationElement();
        }

        protected override Object GetElementKey(ConfigurationElement element)
        {
            return ((OperationElement)element).Action;
        }

        public int IndexOf(OperationElement operation)
        {
            return BaseIndexOf(operation);
        }

        public void Add(OperationElement operation)
        {
            BaseAdd(operation);
        }

        protected override void BaseAdd(ConfigurationElement element)
        {
            BaseAdd(element, false);
        }

        public void Remove(OperationElement operation)
        {
            if (BaseIndexOf(operation) >= 0)
                BaseRemove(operation.Action);
        }

        public void RemoveAt(int index)
        {
            BaseRemoveAt(index);
        }

        public void Remove(string name)
        {
            BaseRemove(name);
        }

        public void Clear()
        {
            BaseClear();
        } 
        #endregion
    }
}
