using System;
using System.IO;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.Runtime.Serialization;
using System.ServiceModel.Dynamic.Test.ServiceModel.Cache;

namespace System.ServiceModel.Dynamic.Test.ServiceModel.Cache
{
    public class MessageCacheItem
    {

        public readonly object SyncRoot = new object();

        #region Public Constructors
        public MessageCacheItem()
        {

        }

        public MessageCacheItem(string action,
                                byte[] buffer,
            TimerExpiration timer)
        {
            this.Action = action;
            this.Buffer = buffer;
            this.Timer = timer;
        }

        #endregion

        #region Public Properties
        
        /// <summary>
        /// Gets or sets the WS-Addressing action of the request message.
        /// </summary>
        public string Action { get; set; }

        /// <summary>
        /// Gets or sets the data.
        /// </summary>
        /// <value>The buffer.</value>
        public byte[] Buffer { get; set; }

        /// <summary>
        /// Gets or sets the timer.
        /// </summary>
        /// <value>The timer.</value>
        public TimerExpiration Timer { get; set; }

        #endregion




        
    }
}
