using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using System.ServiceModel.Dynamic.Test.ServiceModel.Cache;

namespace System.ServiceModel.Dynamic.Test.ServiceModel.Cache.Providers
{

    public class MemoryCache : ICache
    {


        private Hashtable _dic = new Hashtable();


        public MemoryCache()
        {
            
        }


        public void Add<T>(string key, T value, TimerExpiration timeout)
            where T : class
        {

            MessageCacheItem v = value as MessageCacheItem;

            if (!_dic.ContainsKey(key))
            {

                lock (_dic.SyncRoot)
                {
                    if (!_dic.ContainsKey(key))
                    {
                        _dic.Add(key, value);
                        timeout.Reset();
                    }
                    else
                    {
                        lock (v.SyncRoot)
                        {
                            MessageCacheItem v2 = _dic[key] as MessageCacheItem;
                            Array.Copy(v.Buffer, v2.Buffer, v.Buffer.Length);
                            if (v2.Timer.Sliding)
                                v2.Timer.Reset();
                        }
                    }
                }
            }
            else
            {
                lock (v.SyncRoot)
                {
                    MessageCacheItem v2 = _dic[key] as MessageCacheItem;
                    Array.Copy(v.Buffer, v2.Buffer, v.Buffer.Length);
                    if (v2.Timer.Sliding)
                        v2.Timer.Reset();
                }
            }
        }


        public T Get<T>(string key)
            where  T : class
        {

            MessageCacheItem v2 = null;

            if (_dic.ContainsKey(key))
            {

                v2 = _dic[key] as MessageCacheItem;

                if (v2.Timer.IsExpired)
                {
                    v2 = null;
                    lock (_dic.SyncRoot)
                    {
                        _dic.Remove(key);
                    }
                }
                else
                {
                    if (v2.Timer.Sliding)
                        v2.Timer.Reset();
                }
                

            }

            return v2 as T;

        }


    }
}
