using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace System.ServiceModel.Dynamic.Test.ServiceModel.Cache
{
    
    public class TimerExpiration
    {


        public TimerExpiration(TimeSpan timeExpirationSpan)
        {
            TimeExpirationSpan = timeExpirationSpan;
        }

        public bool Sliding { get; set; }
        public TimeSpan TimeExpirationSpan { get; set; }
        public DateTime TimeExpiration { get; private set; }


        public void Reset()
        {
            Reset(DateTime.Now);
        }


        public void Reset(DateTime time)
        {
            TimeExpiration = time.Add(TimeExpirationSpan);
        }

        public bool IsExpired { get { return TimeExpiration < DateTime.Now; } }

    }
}
