using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace System.ServiceModel.Dynamic.Test.ServiceModel.Cache
{
    //A strongly typed AsyncResult
    abstract class TypedAsyncResult<T> : AsyncResult
    {
        #region Private Fields
        T data;
        #endregion

        #region Public Constructors
        public TypedAsyncResult(AsyncCallback callback, object state)
            : base(callback, state)
        {
        }
        #endregion

        #region Public Properties
        public T Data
        {
            get { return data; }
        }
        #endregion

        #region Protected Methods
        protected void Complete(T data, bool completedSynchronously)
        {
            this.data = data;
            Complete(completedSynchronously);
        }
        #endregion

        #region Public Methods
        public static T End(IAsyncResult result)
        {
            TypedAsyncResult<T> typedResult = AsyncResult.End<TypedAsyncResult<T>>(result);
            return typedResult.Data;
        }
        #endregion
    }
}
