﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.IO;
using devtm.Aop.Convert;
using System.Reflection;
using ContractAop;

namespace devtm.Aop.Test
{
    [TestClass]
    public class UnitTest1
    {
        [TestMethod]
        public void TestMethod1()
        {

            Assembly ass = GetAssembly();

            Type t = ass.GetType("ClassTestBuild.ClassTestCache");

            IClassTestCache i = Activator.CreateInstance(t) as IClassTestCache;

            string a = i.Test1("a");
            System.Threading.Thread.Sleep(1000);
            string b = i.Test1("b");

            Assert.AreNotEqual(a, b);

            a = i.Test1("c");
            System.Threading.Thread.Sleep(1000);
            b = i.Test1("c");
            Assert.AreEqual(a, b);

        }





        private static Assembly GetAssembly()
        {
            string path = AppDomain.CurrentDomain.BaseDirectory.Replace(@"devtm.Aop.Test\bin\Debug", @"ClassTestBuild\bin\Debug");
            string FileName = Path.Combine(path, @"ClassTestBuild.dll");


            // Converti par des attributs declarés sur les methodes.
            MethodValidator validator = new MethodValidator();

            bool script = System.Diagnostics.Debugger.IsAttached;

            // Traitement
            CodeDomIILVisitorConverter visitor = new CodeDomIILVisitorConverter(FileName, null, script);

            Assembly ass = null;
            try
            {
                ass = visitor.AnalyzeAndLoadMemory(validator);
            }
            catch (Exception ex)
            {

                throw;
            }
            return ass;
        }
    }
}
